%define	major	0
%define	libname	%mklibname decoration %major
%define	devname %mklibname decoration -d
# List of plugins passed to ./configure.  The order is important

%global    core_plugins    blur clone cube decoration fade ini inotify minimize move place png regex resize rotate scale screenshot switcher water wobbly zoom fs obs commands wall annotate svg matecompat
# List of plugins passed to ./configure.  The order is important
%global    plugins         core,dbus,decoration,fade,minimize,move,obs,place,png,resize,scale,screenshot,svg,switcher,wall

%define	rel		7
%define release %mkrel %{rel}

Name:		compiz
Version:	0.8.18
Release:	%{release}
Summary:	OpenGL composite manager for Xgl and AIGLX
Group:		System/X11
URL:		https://github.com/compiz-reloaded/compiz
License:	GPLv2+ and LGPLv2+ and MIT
Source0:	https://github.com/compiz-reloaded/compiz/archive/v%{version}/%{name}-%{version}.tar.xz
Source1:    image-top.png
Source10:	compiz.defaults
Source11:	compiz-fusion
Source12:	compiz-fusion.defaults

Patch0:         %{name}-pclinuxos-logo.patch
# PATCH-FIX-UPSTREAM compiz-java-config-notify.diff dreveman@novell.com -- Java config notify workaround.
Patch1:         %{name}-java-config-notify.diff
# PATCH-FIX-UPSTREAM bsc#474862 dreveman@novell.com -- Allow moving focus to fs window.
Patch2:         bug-474862-allow-moving-focus-to-fs-window.diff
# Try emerald first as gtk will be loaded in the absence of emerald package
Patch3:         %{name}_try_emerald_first.patch
# Don't call decorator twice
Patch4:         %{name}-%{version}-dont-decorate-twice.patch
#Patch5:			fix-plugins-svg.c-rsvg-features-include.patch

# FTBFS fix, this can be dropped with compiz > 0.8.18
Patch100:        compiz-0.8.18-fix-librsvg-2.51.patch
# https://gitlab.com/compiz/compiz-core/-/merge_requests/177
Patch101:		compiz-0.8.18-gcc-14-fix.patch
# https://gitlab.com/compiz/compiz-core/-/merge_requests/175
Patch102:		compiz-0.8.18-libxml2.patch

BuildRequires:	gettext-devel
BuildRequires:	intltool
BuildRequires:	xsltproc
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(ice)
BuildRequires:	pkgconfig(sm)
BuildRequires:	%{_lib}png-devel
BuildRequires:	%{_lib}jpeg-devel
BuildRequires:	%{_lib}tiff-devel
BuildRequires:	%{_lib}mesaglu1-devel
BuildRequires:	%{_lib}dbus-glib-1_2-devel
BuildRequires:	%{_lib}xml2-devel
BuildRequires:	%{_lib}fuse3-devel
BuildRequires:	pkgconfig(cairo-xlib-xrender)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	%{_lib}rsvg2-devel
BuildRequires:	%{_lib}wnck3-devel
BuildRequires:	%{_lib}marco-private-devel

Requires:	compizconfig
Requires:	compositing-wm-common
Provides:	compiz-decorator
Provides:	compiz-decorator-gtk = %{version}
Conflicts:	compiz-decorator-gtk < 0.8.16

%description
Compiz is an OpenGL compositing manager, which means that it enhances
the overall user interaction by adding fancy effects to your windows,
from drop shadows to desktop effects like the Desktop Cube or the Expo view.

Compiz can also be a window manager, which means that it is the software
between you and your desktop apps. It enables you to move or resize windows,
to switch workspaces, to switch windows easily (using alt-tab or so), and so on.


%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/%{name}
%{_bindir}/%{name}-window-decorator
%{_bindir}/%{name}-decorator
%{_bindir}/%{name}-fusion
%{_libdir}/%{name}/
%{_datadir}/%{name}/
%{_datadir}/compositing-wm/%{name}.defaults
%{_datadir}/compositing-wm/%{name}-fusion.defaults
%{_datadir}/applications/compiz-start.desktop
%{_datadir}/applications/compiz.desktop
%{_iconsdir}/hicolor/*/apps/compiz.*
%{_bindir}/gtk-window-decorator
%{_iconsdir}/hicolor/*/apps/gtk-decorator.*
%{_datadir}/glib-2.0/schemas/org.compiz-0.gwd.gschema.xml

#----------------------------------------------------------------------------

%package -n %libname
Summary:	Shared libraries for compiz
Group:		System/X11
Obsoletes:	%{_lib}compiz0 < 0.9.14

%description -n %libname
This package provides shared libraries for compiz.

%files -n %libname
%{_libdir}/libdecoration.so.%{major}*

#----------------------------------------------------------------------------

%package -n %devname
Summary:	Development files for compiz
Group:		Development/X11
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{_lib}compiz-devel < 0.9.14

%description -n %devname
This package provides development files for compiz.

%files -n %devname
%{_includedir}/%{name}/
%{_libdir}/libdecoration.so
%{_libdir}/pkgconfig/compiz-cube.pc
%{_libdir}/pkgconfig/compiz-scale.pc
%{_libdir}/pkgconfig/compiz.pc
%{_libdir}/pkgconfig/libdecoration.pc

#----------------------------------------------------------------------------

%prep
%setup -n %{name}-%{version}
cp -a %{SOURCE1} image-top.png
%autopatch -p1
mkdir -p m4

%build
autoreconf -vfi -Im4
intltoolize --force
# mesa is now with glvnd=true...
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"
%configure2_5x \
	--disable-rpath \
	--disable-static \
	--with-gtk=3.0 \
	--enable-gtk \
	--enable-marco \
	--enable-librsvg \
	--enable-menu-entries \
	--with-default-plugins=%{plugins}
%make_build

%install
%make_install
install -Dpm644 %{_sourcedir}/image-top.png %{buildroot}%{_datadir}/compiz/%{_real_vendor}.png
install -D -m644 %{_sourcedir}/%{name}.defaults %{buildroot}%{_datadir}/compositing-wm/%{name}.defaults
install -m755 %{_sourcedir}/%{name}-fusion %{buildroot}%{_bindir}/%{name}-fusion
install -m644 %{_sourcedir}/%{name}-fusion.defaults %{buildroot}%{_datadir}/compositing-wm/%{name}-fusion.defaults

# we don't want these
find %{buildroot} -name "*.la" -delete

# Compiz now provides a script to choose decorator, so we dropped our own
# make a link to not break existing setup which rely on former script.
ln -s %{_bindir}/%{name}-decorator %{buildroot}/%{_bindir}/%{name}-window-decorator

%find_lang %{name}

%post 
/sbin/ldconfig
if [ -s $HOME/.config/compiz-1/compizconfig/Default.ini ]; then
rm -f $HOME/.config/compiz-1/compizconfig/Default.ini
echo "[core]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "as_active_plugins = core;ccp;move;resize;place;decoration;png;wobbly;glib;regex;svg;cube;rotate;" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo " " >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "[cube]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "s0_images = mandriva;" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo " " >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "#[decoration]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "#as_command = /usr/bin/compiz-decorator --replace" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo
fi

%posttrans 
/sbin/ldconfig
if [ -s $HOME/.config/compiz-1/compizconfig/Default.ini ]; then
rm -f $HOME/.config/compiz-1/compizconfig/Default.ini
echo "[core]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "as_active_plugins = core;ccp;move;resize;place;decoration;png;wobbly;glib;regex;svg;cube;rotate;" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo " " >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "[cube]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "s0_images = mandriva;" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo " " >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "#[decoration]" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo "#as_command = /usr/bin/compiz-decorator --replace" >> $HOME/.config/compiz-1/compizconfig/Default.ini
echo
fi

%postun 
/sbin/ldconfig
if [ -s $HOME/.config/compiz-1/compizconfig/Default.ini ]; then
rm -f $HOME/.config/compiz-1/compizconfig/Default.ini
fi

%changelog
* Fri Feb 16 2024 yodelu - 0.8.18-7pclos2024
- fix crash due latest updates (libxml2)

* Fri Jan 27 2023 yodelu - 0.8.18-6pclos2023
- enable marco

* Thu Jan 26 2023 tex - 0.8.18-5pclos2023.1
- rebuild against updates

* Mon Jan 16 2022 yodelu 0.8.18-5pclos2023
- rebuild against updates (mesa/librsvg)

* Sat Oct 09 2021 yodelu 0.8.18-5pclos2021
- rebuild against updates

* Mon Nov 16 2020 yodelu 0.8.18-4pclos2020
- Don't call compiz-decorator = don't decorate twice
- kill all compiz instances before doing start-up script (useful for login/logout)
- drop default fade plugin as it fails on nouveau > close-window

* Fri Nov 13 2020 yodelu 0.8.18-3pclos2020
-  change default used plugins
-  try emerald decorator first (in case emerald got installed)
-  reworked compiz-fusion script (make plasma5 happy) +
-  don't call compiz-decorator from compiz config file 

* Tue Nov 10 2020 yodelu 0.8.18-2pclos2020
- rebuild

* Sat Apr 18 2020 yodelu 0.8.18-1pclos2020
- Imported again to pclinuxos
